#ifndef __CRYPTOID_IMPORT_H__
#define __CRYPTOID_IMPORT_H__

#ifdef WIN32 

#ifdef _DEBUG
#ifndef _CONSOLE
#pragma comment(linker, "/NODEFAULTLIB:libcmt.lib")
#endif
#endif

#endif


#ifdef __cplusplus
extern "C"
{
#endif

	long  CryptoIDInit();
	long  CryptoIDSetUserPin(char *oldUpin, char *newUpin);
	long  CryptoIDFormat(char *soPin, char *newSoPin, char *newUPin, char *label, char *manufacture,  int uPinRetryTimes, int soPinRetryTimes, int minUPinLen, int maxUPinLen, int minSoPinLen, int maxSoPinLen);
	long  CryptoIDChangeUPin(char *soPin, char *newUPin);
	long  CryptoIDChangeSoPin(char *soPin, char *newSoPin);
	long  CryptoIDLogin(char *uPin, long *left);

	long  CryptoIDImportCert(char *filePath, char *ContainerName, char *passWord, long algId,  long cerType);
	long  CryptoIDImportKeyPair(char *ContainerName, unsigned char *pbData, long bDataLen, long algId);
	long  CryptoIDGenCSR(char * ContainerName, long algId, long KeyLength, char * DN, char * certBase64, long * certBase64_size);
	long  CryptoIDGetKeyInfo(long * totalMemory, long *freeMemory);
	long  CryptoIDDeleteContainer(char *szContainer);
	long  CryptoIDDeleteRootCertData(char *szContainer, char *upin);
	long  CryptoIDEnumContainer(char *szTotalContainer, long * containerNumber);

	long  CryptoIDUninitialize();

#ifdef __cplusplus
}
#endif



#endif 
