﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.Runtime.InteropServices;

namespace CryptoIDA_NET
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }
        [DllImport("CryptoIDImprot.dll", CharSet = CharSet.Ansi, CallingConvention = CallingConvention.Cdecl)]
        public extern static int CryptoIDImportCert(byte[] filePath, byte[] ContainerName, byte[] passWord, int algId, int cerType);

        [DllImport("CryptoIDImprot.dll", CharSet = CharSet.Ansi, CallingConvention = CallingConvention.Cdecl)]
        public extern static int CryptoIDImportKeyPair(byte[] ContainerName, byte[] pbData, int bDataLen, int algId);

        [DllImport("CryptoIDImprot.dll", CharSet = CharSet.Ansi, CallingConvention = CallingConvention.Cdecl)]
        public extern static int CryptoIDGenCSR(string ContainerName, int algId, int KeyLength, string DN, byte[] certBase64, int[] certBase64_size);

        [DllImport("CryptoIDImprot.dll", CharSet = CharSet.Ansi, CallingConvention = CallingConvention.Cdecl)]
        public extern static int CryptoIDGetKeyInfo(int[] totalMemory, int[] freeMemory);

        [DllImport("CryptoIDImprot.dll", CharSet = CharSet.Ansi, CallingConvention = CallingConvention.Cdecl)]
        public extern static int CryptoIDEnumContainer(byte[] szTotalContainer, int[] containerNumber);

        [DllImport("CryptoIDImprot.dll", CharSet = CharSet.Ansi, CallingConvention = CallingConvention.Cdecl)]
        public extern static int CryptoIDDeleteContainer(string szContainer);

        [DllImport("CryptoIDImprot.dll", CharSet = CharSet.Ansi, CallingConvention = CallingConvention.Cdecl)]
        public extern static int CryptoIDDeleteRootCertData(string szContainer, string upin);

        [DllImport("CryptoIDImprot.dll")]
        public extern static int CryptoIDInit();

        [DllImport("CryptoIDImprot.dll")]
        public extern static int CryptoIDSetUserPin(byte[] oldUpin,byte[] newUpin);

        [DllImport("CryptoIDImprot.dll")]
        public extern static int CryptoIDFormat(string soPin, string newSoPin, string newUPin, string label, string manufacture,  uint uPinRetryTimes,  uint soPinRetryTimes,  uint minUPinLen,  uint maxUPinLen,  uint minSoPinLen,  uint maxSoPinLen);

        [DllImport("CryptoIDImprot.dll")]
        public extern static int CryptoIDChangeUPin(byte[] soPin, byte[] newUPin);

        [DllImport("CryptoIDImprot.dll")]
        public extern static int CryptoIDChangeSoPin(byte[] soPin, byte[] newSoPin);

        [DllImport("CryptoIDImprot.dll")]
        public extern static int CryptoIDLogin(byte[] uPin, int[] left);

        [DllImport("CryptoIDImprot.dll")]
        public extern static int CryptoIDUninitialize();


        /// <summary>
        /// Select the certificate file to import.
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void button1_Click_1(object sender, EventArgs e)
        {
            OpenFileDialog file = new OpenFileDialog();
            if (file.ShowDialog() == DialogResult.OK)
            {
                this.textBox1.Text = file.FileName;
            }
        }

        /// <summary>
        /// The import certificate
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void button2_Click_1(object sender, EventArgs e)
        {
            //Certificate password
            byte[] passWord = Encoding.UTF8.GetBytes(this.textBox2.Text.Trim());
            //Address of the certificate
            byte[] filePath = Encoding.UTF8.GetBytes(this.textBox1.Text);
            //Container name
            byte[] ContainerName = Encoding.UTF8.GetBytes(this.textBox3.Text);
            //Encryption type
            int algId = Encryption_type;
            /**
             * cerType:
             * [IN] 0 user certificate, 1 root certificate. When filePathCer file format is cer, select user certificate or root certificate
             * Value range: 0 and 1
             * 0: user certificate, no need to enter user password, it can be empty
             * 1: Root certificate, need to input user PIN
             * */
            int cerType = Convert.ToInt32(this.textBox9.Text.Trim());
            int Rtn = CryptoIDImportCert(filePath, ContainerName, passWord, algId, cerType);
            if (Rtn != 0)
            {
                MessageBox.Show("Error:Import certificate failed!Error：" + Rtn.ToString());
                return;
            }
            MessageBox.Show("Import certificate successful");
        }


        /// <summary>
        /// Import secret key pair
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void button3_Click(object sender, EventArgs e)
        {
            //Container name
            byte[] ContainerName = Encoding.UTF8.GetBytes(this.textBox3.Text);
            //RSA Key pair
            byte[] pbData ={0x07,0x02,0x00,0x00,0x00,0xa4,0x00,0x00,0x52,0x53,0x41,0x32,0x00,0x04,0x00,0x00,
	                        0x01,0x00,0x01,0x00,0xa3,0x9a,0x2b,0x65,0x5c,0x9c,0xa5,0x7c,0x91,0xea,0x17,0xe8,
	                        0xc4,0xa7,0xee,0xb5,0x23,0x23,0x36,0x35,0x91,0xe4,0x40,0xb0,0x0c,0x11,0xe0,0xb7,
	                        0x07,0x67,0x20,0x99,0x08,0x90,0x55,0x24,0x7d,0x89,0x98,0x81,0x71,0x1f,0x71,0x03,
	                        0x99,0x5a,0x06,0x31,0xdf,0x87,0x2e,0x97,0xa9,0x36,0x76,0xc1,0xb8,0x59,0x3c,0xd6,
	                        0x6a,0xb9,0x5d,0x17,0x3c,0x10,0x2e,0x0f,0xeb,0x4a,0x5f,0x26,0xa7,0x5d,0x28,0xa3,
	                        0x5a,0x43,0xf9,0xe7,0x50,0xaa,0x8f,0x46,0xef,0x6f,0xd0,0x0f,0x77,0x60,0x65,0x9b,
	                        0x08,0x03,0xaf,0x7f,0x7a,0x21,0x38,0xb1,0x52,0x91,0x34,0x71,0x84,0x24,0x45,0xa6,
	                        0x47,0x67,0x64,0x2b,0x49,0x55,0xa9,0x46,0x0c,0x33,0x23,0x01,0x42,0xa6,0x90,0xbe,
	                        0xeb,0xe2,0x42,0xbd,0x7d,0x9a,0x64,0x90,0x19,0x1e,0xd4,0xd9,0x47,0x86,0x64,0x65,
	                        0xb1,0x55,0xb6,0x16,0x5b,0x4f,0xf7,0xa1,0x82,0xdd,0xea,0x7d,0x87,0x6a,0xd5,0xad,
	                        0x4e,0x9d,0xb9,0x93,0x57,0xce,0x1c,0xb7,0xa0,0xdc,0x96,0xb5,0x6a,0xeb,0x5b,0x6d,
	                        0xba,0xee,0x3d,0xd9,0x60,0xcb,0x22,0x64,0x0f,0x51,0x35,0x80,0x10,0xc1,0x13,0xc0,
	                        0xf8,0x87,0x48,0xdf,0x9f,0xf3,0x27,0x9b,0xfb,0x69,0xaa,0x8c,0xa6,0x4b,0xf7,0x8d,
	                        0xf9,0x04,0xf5,0x24,0xe1,0x53,0xa3,0x0e,0xde,0xfe,0x43,0x61,0xab,0xb5,0x2f,0xd8,
	                        0x4e,0x19,0xde,0x98,0x49,0x52,0xfb,0xb5,0xb3,0x33,0x61,0x7f,0xff,0xb8,0xec,0xe5,
	                        0xf6,0x4b,0x5e,0x2a,0x42,0x10,0x7b,0x68,0x7f,0xc4,0x80,0xa0,0xb6,0xee,0x23,0xfd,
	                        0xd4,0x2b,0xfe,0xd8,0x81,0x83,0xc7,0x4d,0x54,0x23,0x78,0xe4,0x97,0x26,0x14,0x3f,
	                        0x51,0x54,0xae,0x35,0xbf,0x03,0xbc,0x3d,0x99,0x75,0xf4,0x24,0x49,0xf9,0x8f,0x4d,
	                        0x17,0x8a,0x70,0x82,0x55,0x92,0xc0,0xdb,0x7b,0x01,0x10,0x52,0x8c,0x61,0x1f,0x12,
	                        0xfa,0xd1,0xd8,0xe5,0x00,0x23,0x21,0x5c,0x4b,0x9c,0xea,0x07,0xc4,0x93,0x90,0xc6,
	                        0xd2,0x0e,0x52,0x80,0x7b,0x0f,0x6d,0x02,0xb0,0x2e,0xdc,0xf2,0xdf,0x47,0x6a,0x3b,
	                        0x84,0x81,0x3c,0x8e,0x1a,0x9d,0xcd,0x15,0x80,0xe4,0x08,0xad,0x6c,0xfc,0xbb,0xaa,
	                        0xef,0x3f,0xe6,0x71,0xb5,0xa3,0x4e,0x70,0x6d,0xc4,0x95,0xde,0x82,0x09,0xc6,0x8f,
	                        0xa3,0x72,0xf3,0x28,0x0c,0x23,0x7b,0x85,0xa8,0x58,0x62,0x90,0x42,0x00,0x78,0x00,
	                        0xe9,0x56,0xd9,0xc1,0xe3,0xa6,0x57,0x17,0xdb,0xb3,0x2d,0x3a,0xb0,0x70,0xdc,0x22,
	                        0xd1,0x6a,0xfb,0x3e,0x0d,0x13,0x37,0x56,0xe6,0x04,0x35,0x75,0x5f,0xf3,0xfd,0xf7,
	                        0x4b,0x3e,0xd4,0x0a,0x53,0x1c,0x5b,0xe1,0x0c,0xa4,0xf9,0x25,0x86,0x36,0xc6,0x5e,
	                        0x6f,0x48,0xdc,0xf8,0x94,0xe5,0x48,0x7d,0xfb,0x72,0x19,0x6d,0x86,0x4f,0x58,0xbc,
	                        0xd7,0xe0,0xb9,0x73,0xf9,0xdb,0x1b,0xe2,0x2a,0x52,0xf9,0x78,0xb2,0xe7,0xc9,0xe2,
	                        0x25,0x48,0xa3,0x58,0x1e,0xb3,0xfa,0xef,0x82,0x5d,0xb2,0x6b,0x77,0x52,0x3b,0x63,
	                        0x00,0xe2,0xd0,0xb2,0x81,0x5f,0xc2,0x00,0x65,0xd2,0x0b,0x3c,0x28,0x00,0x84,0x03,
	                        0xd5,0x6f,0xdf,0x25,0x0a,0x68,0xa8,0xce,0x65,0xe6,0x83,0x89,0x3f,0x66,0xec,0xb8,
	                        0xcc,0xb2,0x56,0x1c,0x74,0x0c,0x87,0x51,0x61,0x20,0xbd,0x85,0x73,0x78,0x15,0xc4,
	                        0x2b,0xed,0xe7,0xb7,0x74,0xa3,0xe9,0xb2,0x07,0x82,0xec,0xba,0x46,0xaa,0x3a,0xb2,
	                        0x20,0xb1,0x8d,0x66,0x94,0xc9,0x6a,0x7d,0x59,0xa7,0x2a,0x5f,0x83,0x64,0xac,0x12,
	                        0xe8,0x0d,0x80,0x9b,0xe3,0xad,0x06,0x46,0xa1,0x71,0x9c,0x92,0x6a,0x73,0x70,0x0e,
	                        0x2c,0x64,0xa8,0x1a};
            //Encryption type
            int algId = Encryption_type;

            int Rtn = CryptoIDImportKeyPair(ContainerName, pbData, pbData.Length, algId);
            if (Rtn != 0)
            {
                MessageBox.Show("Import the secret key to fail！Error：" + Rtn.ToString());
                return;
            }
            MessageBox.Show("Import the secret key to success.");
        }
        int Encryption_type = 0;
        private void Form1_Load(object sender, EventArgs e)
        {
            this.comboBox1.SelectedIndex = 0;
            this.comboBox2.SelectedIndex = 0;
            //comboBox1_SelectedIndexChanged(sender, e);

        }

        private void comboBox1_SelectedIndexChanged_1(object sender, EventArgs e)
        {

            if (this.comboBox1.SelectedIndex == 0)
            {
                Encryption_type = 1;
            }
            else
            {
                Encryption_type = 2;
            }
        }

        /// <summary>
        /// Generate CSR
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void button4_Click_1(object sender, EventArgs e)
        {
            this.textBox5.Clear();
            if (this.textBox3.Text == string.Empty)
            {
                MessageBox.Show("Please enter the name of the container!");
                return;
            }
            if (this.textBox4.Text == string.Empty)
            {
                MessageBox.Show("Please fill in Distinct Name!");
                return;
            }
            //Container name
            string ContainerName = this.textBox3.Text;
            //Encryption type
            int algId = Encryption_type;
            //KeyLength
            int KeyLength = Convert.ToInt32(this.comboBox2.Text);
            //Distinct Name
            string DN = this.textBox4.Text;
            //[OUT] CSR data buffer
            byte[] certBase64 = new byte[1024];
            //[OUT] CSR data buffer length
            int[] certBase64_size = new int[8];
            certBase64_size[0] = 1024;
            int Rtn = CryptoIDGenCSR(ContainerName, algId, KeyLength, DN, certBase64, certBase64_size);
            if (Rtn != 0)
            {
                MessageBox.Show("Failed to generate CSR!Error：" + Rtn.ToString());
                return;
            }
            this.textBox5.Text = Encoding.UTF8.GetString(certBase64);

        }

        /// <summary>
        /// Get space
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void button5_Click_1(object sender, EventArgs e)
        {
            this.textBox6.Text = string.Empty;
            this.textBox7.Text = string.Empty;
            int[] totalMemory = new int[8];
            int[] freeMemory = new int[8];
            int Rtn = CryptoIDGetKeyInfo(totalMemory, freeMemory);
            if (Rtn != 0)
            {
                MessageBox.Show("Failed to get space!Error：" + Rtn.ToString());
                return;
            }
            else
            {
                this.textBox6.Text = totalMemory[0].ToString();
                this.textBox7.Text = freeMemory[0].ToString();
            }

        }

        /// <summary>
        /// Enumerate the container
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void button6_Click(object sender, EventArgs e)
        {
            this.comboBox3.Items.Clear();
            byte[] szTotalContainer = new byte[1024];
            int[] containerNumber = new int[8];
            int Rtn = CryptoIDEnumContainer(szTotalContainer, containerNumber);
            if (Rtn != 0)
            {
                MessageBox.Show("Failed to enumerate the container!Error:" + Rtn.ToString());
                return;
            }
            else
            {
                string szTotalContainer_Text = Encoding.UTF8.GetString(szTotalContainer);
                string[] sArray = szTotalContainer_Text.Split(new string[] { "||" }, StringSplitOptions.RemoveEmptyEntries);
                for (int i = 0; i < sArray.Length - 1; i++)
                {
                    this.comboBox3.Items.Add(sArray[i].ToString());
                }
                this.comboBox3.SelectedIndex = 0;

            }
        }

        private void button7_Click(object sender, EventArgs e)
        {
            if (this.comboBox3.Text == string.Empty)
            {
                MessageBox.Show("Please enumerate the container！");
                return;
            }
            string szContainer = this.comboBox3.Text;
            int Rtn = CryptoIDDeleteContainer(szContainer);
            if (Rtn != 0)
            {
                MessageBox.Show("failed to delete!Error:" + Rtn.ToString());
                return;
            }
            else
            {
                MessageBox.Show("successfully deleted");
            }
        }

        /// <summary>
        /// Root Cert container name cannot be enumerated, please specify the name of the container to be deleted in the method
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void button8_Click_1(object sender, EventArgs e)
        {
            string szContainer = this.comboBox3.Text;
            //Before deleting, please enter userPin
            string pwd = this.textBox2.Text.Trim();
            if (pwd == null || pwd == "")
            {
                MessageBox.Show("Please fill in the certificate password");
                return;
            }
            if (this.textBox8.Text == "" || this.textBox8.Text == null)
            {
                MessageBox.Show("Please enter the container name to delete the root certificate！");
                return;
            }
            int Rtn = CryptoIDDeleteRootCertData(this.textBox8.Text.Trim(), pwd);
            if (Rtn != 0)
            {
                MessageBox.Show("Root cert to delete!Error:" + Rtn.ToString());
                return;
            }
            else
            {
                MessageBox.Show("Root cert to delete successfully ");
            }
        }
        
        private void comboBox4_SelectedIndexChanged(object sender, EventArgs e)
        {
           
        }

        /// <summary>
        /// initialization,Call this interface before calling the interface;
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void initialization_Click(object sender, EventArgs e)
        {
            int Rtn1 = CryptoIDInit();
            if (Rtn1!=0)
            {
                MessageBox.Show("failed!Error:"+Rtn1.ToString());
                return;
            }
            MessageBox.Show("successful");
        }

        /// <summary>
        /// Set user password,Modify new user password through user password
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void Modify_Click(object sender, EventArgs e)
        {
            byte[] oldUpin = Encoding.UTF8.GetBytes(this.oldUpin.Text.Trim());
            byte[] newUpin = Encoding.UTF8.GetBytes(this.newUpin.Text.Trim());
            int Rtn2 = CryptoIDSetUserPin(oldUpin,newUpin);
            if (Rtn2!=0)
            {
                MessageBox.Show("failed!Error:"+Rtn2.ToString());
                return;
            }
            MessageBox.Show("successful");

        }

        /// <summary>
        /// Set administrator password, format, format and At the same time set the administrator password, user password
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void carried_out_Click(object sender, EventArgs e)
        {
            //[ IN ] management password
            string soPin = this.soPin.Text.Trim();
            //[ IN ] New administrative password
            string newSoPin = this.newSoPin.Text.Trim();
            //[ IN ] New user password
            string newUPin = this.Set_newUPin.Text.Trim();
            //[ IN ] Product Name
            string label = this.label.Text.Trim();
            //[ IN ] Manufacturer Name
            string manufacture = this.manufacture.Text.Trim();
            //[IN] User password retries (1-15)
            uint uPinRetryTimes = Convert.ToUInt32(this.uPinRetryTimes.Text.Trim()); 
            //[IN ] number of administrative password retries (1-15)
            uint soPinRetryTimes = Convert.ToUInt32(this.soPinRetryTimes.Text.Trim());
            //[IN] The minimum length of the user password (4-16)
            uint minUPinLen = Convert.ToUInt32(this.minUPinLen.Text.Trim());
            //[IN] Maximum length of user password (4-16)
            uint maxUPinLen = Convert.ToUInt32(this.maxUPinLen.Text.Trim());
            //Minimum length of the [IN] management password (4-16)
            uint minSoPinLen = Convert.ToUInt32(this.minSoPinLen.Text.Trim());
            //Maximum length of [IN] management password (4-16)
            uint maxSoPinLen = Convert.ToUInt32(this.maxSoPinLen.Text.Trim());
            int Rtn3 = CryptoIDFormat(soPin, newSoPin, newUPin, label, manufacture, uPinRetryTimes,  soPinRetryTimes,  minUPinLen,  maxUPinLen,  minSoPinLen,  maxSoPinLen);
            if (Rtn3!=0)
            {
                MessageBox.Show("failed!Error:"+Rtn3.ToString());
                return;
            }
            MessageBox.Show("successful");
        }

        /// <summary>
        /// Change user password,Modify the user password through the management password
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void button9_Click(object sender, EventArgs e)
        {
            byte[] Ch_soPin = Encoding.UTF8.GetBytes(this.Ch_soPin.Text.Trim());
            byte[] Ch_newUPin = Encoding.UTF8.GetBytes(this.Ch_newUPin.Text.Trim());
            int Rtn4 = CryptoIDChangeUPin(Ch_soPin, Ch_newUPin);
            if (Rtn4!=0)
            {
                MessageBox.Show("failed!Error:"+Rtn4.ToString());
                return;
            }
            MessageBox.Show("successful");
        }

        /// <summary>
        /// Change the management password,Change the management password through the management password
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void button10_Click(object sender, EventArgs e)
        {
            byte[] Ch_soPin1 = Encoding.UTF8.GetBytes(this.Ch_soPin1.Text.Trim());
            byte[] Ch_newSoPin1 = Encoding.UTF8.GetBytes(this.Ch_newSoPin1.Text.Trim());
            int Rtn5=CryptoIDChangeSoPin(Ch_soPin1,Ch_newSoPin1);
            if (Rtn5!=0)
            {
                MessageBox.Show("failed!Error:" + Rtn5.ToString());
                return;
            }
            MessageBox.Show("successful");
        }

        /// <summary>
        /// Execute all commands through user password (this function is open permission, please verify other functions after opening permissions)
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void button11_Click(object sender, EventArgs e)
        {
            this.textBox11.Text = "";
            byte[] textBox10 = Encoding.UTF8.GetBytes(this.textBox10.Text.Trim());
            int [] textBox11 = new int[1];
            int Rtn6 = CryptoIDLogin(textBox10, textBox11);
            if (Rtn6!=0)
            {
                 MessageBox.Show("failed!Error:" + Rtn6.ToString());
                 this.textBox11.Text = Convert.ToString(textBox11[0]);
                 return;  
            }
            this.textBox11.Text = "successful";
        }

        /// <summary>
        /// Release, call this function without using key, use with CryptoIDInit, and call it when exiting the program or not operating the key. If you need to call the key, call CryptoIDInit first.
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void button12_Click(object sender, EventArgs e)
        {
            int Rtn7 = CryptoIDUninitialize();
            if (Rtn7!=0)
            {
                MessageBox.Show("failed!Error:" + Rtn7.ToString());
                return;
            }
            MessageBox.Show("successful");
        }

        private void groupBox1_Enter(object sender, EventArgs e)
        {

        }



        private void comboBox2_SelectedIndexChanged(object sender, EventArgs e)
        {

        }



      

        




        

        

       

    }
}
